character*4 dsaa/'DSAA'/

character*8 ar,md,line
character*1 gr
character*2 it
allocatable plotray(:,:)
real xray0(10000),yray0(10000),xray(15000),yray(15000)
real ornt(10),xside(4),yside(4)


one=1.d0
pi=asin(one)*2.d0
per=pi/180.d0

val_norm=1

open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter 
close(1)
write(it,'(i2)')iter


sinbase=0.
cosbase=1.

!******************************************************************
open(1,file='../../data/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=533)line
	if(line.eq.'GRID_PAR') goto 534
end do
533 continue
write(*,*)' cannot find GRID_PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
534 continue
read(1,*)xlim1,xlim2,dxpl
read(1,*)ylim1,ylim2,dypl
read(1,*)n_parts
close(1)
!******************************************************************

nxpl=int_best((xlim2-xlim1)/dxpl)+1
nypl=int_best((ylim2-ylim1)/dypl)+1
xlim2=xlim1+(nxpl-1)*dxpl
ylim2=ylim1+(nypl-1)*dypl

write(*,*)' nxpl=',nxpl,' nypl=',nypl

allocate(plotray(nxpl,nypl))
plotray=0
nray=0

open(1,file='../../DATA/'//ar//'/'//md//'/data/rays'//it//'.dat',form='binary')
open(2,file='../../tmp/paths'//it//'.dat',form='binary')

1 read(1,end=2) xzt,yzt,xst,yst,tobs,tmod
	nray=nray+1
	read(2)nodes0
	do i=1,nodes0
		read(2)xray0(i),yray0(i)
	end do
!	write(*,*)nray,nodes,nodes0
	nodes=1
	xray(1)=xray0(1)
	yray(1)=yray0(1)

	do i=1,nodes0-1
		x1=xray0(i)
		y1=yray0(i)
		x2=xray0(i+1)
		y2=yray0(i+1)
		sqr=(x2-x1)**2+(y2-y1)**2
		if(sqr.lt.abs(dypl/1000.))cycle
		ds=sqrt(sqr)
		dss=ds/n_parts
		do ii=1,n_parts
			nodes=nodes+1
			xray(nodes)=x1+((x2-x1)/ds)*(dss*ii)
			yray(nodes)=y1+((y2-y1)/ds)*(dss*ii)
		end do
	end do

	if(mod(nray,500).eq.0) write(*,*)nray,nodes,nodes0

	do ip=2,nodes
		xl1=xray(ip-1)
		xl2=xray(ip)
		yl1=yray(ip-1)
		yl2=yray(ip)
		dss=sqrt((xl1-xl2)**2+(yl1-yl2)**2)

		xmid=(xl1+xl2)/2.
		ymid=(yl1+yl2)/2.


		if((xmid-xlim1)*(xmid-xlim2).gt.0) cycle
		if((ymid-ylim1)*(ymid-ylim2).gt.0) cycle

		do ix=1,nxpl
			x1=xlim1+dxpl*(ix-1)
			x2=xlim1+dxpl*ix
			if((xmid-x1)*(xmid-x2).le.0.)exit
		end do
		do iy=1,nypl
			y1=ylim1+dypl*(iy-1)
			y2=ylim1+dypl*iy
			if((ymid-y1)*(ymid-y2).le.0.)exit
		end do

		plotray(ix,iy)=plotray(ix,iy)+dss

	end do
	!write(*,*)ix,iy

	goto 1

2 close(1)


close(1)
close(2)
write(*,*)' nray=',nray

open(12,file='../../DATA/'//ar//'/'//md//'/data/raydens.dat',form='binary')
write(12)xlim1,xlim2,nxpl,dxpl
write(12)ylim1,ylim2,nypl,dypl
write(12)((plotray(ix,iy),ix=1,nxpl),iy=1,nypl)
!write(*,'(10f7.1)')((plotray(ix,iy),ix=1,nxpl),iy=1,nypl)
close(12)

aver=0
nav=0
do ix=1,nxpl
	do iy=1,nypl
		if(abs(plotray(ix,iy)).lt.1.) cycle
		aver=aver+plotray(ix,iy)
		nav=nav+1
	end do
end do
aver=aver/nav

plotray=plotray*val_norm/aver


open(14,file='../../FIG_files/rays/ray_dens.grd')
write(14,'(a4)')dsaa
write(14,*)nxpl,nypl
write(14,*)xlim1,xlim2
write(14,*)ylim2,ylim1
write(14,*)-999,99999
do iy=nypl,1,-1
	write(14,*)(plotray(ix,iy),ix=1,nxpl)
end do
close(14)




stop
end