character*4 dsaa/'DSAA'/

character*8 ar,md,line
character*1 gr
character*2 it

allocatable dv_map(:,:),www(:,:)

allocatable xgrd(:),ygrd(:),dvgrd(:)
real yline(600,200),xline(600)
integer non_ln(600),kline(600,200)
real ornt(10)

common/pi/pi,per
common/refmod/nref,href(600),vref(600)

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0


open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter
close(1)
write(it,'(i2)')iter

!******************************************************************
open(1,file='../../data/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=523)line
	if(line.eq.'2D GRID') goto 524
end do
523 continue
write(*,*)' cannot find 2D GRID PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
524 continue
read(1,*) xmap1,xmap2,dxmap  
read(1,*) ymap1,ymap2,dymap  
read(1,*) dxmax,dymax  
close(1)
!******************************************************************

nxmap=int_best((xmap2-xmap1)/dxmap)+1
nymap=int_best((ymap2-ymap1)/dymap)+1

allocate(dv_map(nxmap,nymap),www(nxmap,nymap))

write(*,*)' nxmap=',nxmap,' nymap=',nymap

!******************************************************************

dv_map=0
www=0


!******************************************************************

open(1,file='../../data/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=533)line
	if(line.eq.'GRID_PAR') goto 534
end do
533 continue
write(*,*)' cannot find GRID_PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
534 continue
read(1,*)xlim1,xlim2,dxpl
read(1,*)ylim1,ylim2,dypl
read(1,*)n_parts
close(1)
nxpl=int_best((xlim2-xlim1)/dxpl)+1
nypl=int_best((ylim2-ylim1)/dypl)+1
xlim2=xlim1+nxpl*dxpl
ylim2=ylim1+nypl*dypl

!******************************************************************
open(1,file='../../data/'//ar//'/'//md//'/data/grid.dat')
read(1,*)node
allocate(xgrd(node),ygrd(node),dvgrd(node))
do i=1,node
	read(1,*)xgrd(i),ygrd(i)
end do
close(1)

!******************************************************************
open(1,file='../../DATA/'//ar//'/'//md//'/data/dv_result'//it//'.dat')
do i=1,node
	read(1,*)dvgrd(i)		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
end do
close(1)
!******************************************************************



kline=0
nline=1
non_ln(nline)=2
xline(nline)=xlim1
yline(nline,1)=ylim1
yline(nline,2)=ylim2
do ix=1,nxpl
	xln=xlim1+(ix-0.5)*dxpl
	nline=nline+1

	nonln=1
	yline(nline,1)=ylim1

	do inod=1,node
		xxx=xgrd(inod)
		if(abs(xxx-xln).gt.0.001) cycle
		yyy=ygrd(inod)
		nonln=nonln+1
		yline(nline,nonln)=yyy
		kline(nline,nonln)=inod
	end do
	nonln=nonln+1
	yline(nline,nonln)=ylim2
	non_ln(nline)=nonln
	xline(nline)=xln
end do
nline=nline+1
non_ln(nline)=2
xline(nline)=xlim2
yline(nline,1)=ylim1
yline(nline,2)=ylim2

write(*,*)' nline=',nline



do iymap=1,nymap
	ymid=ymap1+(iymap-1)*dymap
	do ixmap=1,nxmap
		xmid=xmap1+(ixmap-1)*dxmap

!write(*,*)' node=',node


		umnn=0
		do i=1,node
			x=xgrd(i)
			y=ygrd(i)

			if(abs(x-xmid).lt.dxmax.and.abs(y-ymid).lt.dymax) then
				umnn=1
				exit
			end if

		end do
!write(*,*)' smin=',smin,' smaxx=',smaxx


		do ix=1,nline-1
			x1=xline(ix)
			x2=xline(ix+1)
			if((xmid-x1)*(xmid-x2).le.0) exit
		end do
		do iy1=1,non_ln(ix)-1
			y11=yline(ix,iy1)
			y12=yline(ix,iy1+1)
			k11=kline(ix,iy1)
			k12=kline(ix,iy1+1)
			if((ymid-y11)*(ymid-y12).le.0) exit
		end do

		do iy2=1,non_ln(ix+1)-1
			y21=yline(ix+1,iy2)
			y22=yline(ix+1,iy2+1)
			k21=kline(ix+1,iy2)
			k22=kline(ix+1,iy2+1)
			if((ymid-y21)*(ymid-y22).le.0) exit
		end do

		dv11=0
		dv12=0
		dv21=0
		dv22=0

		if(k11.ne.0) dv11=dvgrd(k11)
		if(k12.ne.0) dv12=dvgrd(k12)
		if(k21.ne.0) dv21=dvgrd(k21)
		if(k22.ne.0) dv22=dvgrd(k22)

		dv1=dv11+((dv12-dv11)/(y12-y11))*(ymid-y11)
		dv2=dv21+((dv22-dv21)/(y22-y21))*(ymid-y21)
		dvmid=dv1+((dv2-dv1)/(x2-x1))*(xmid-x1)

		dv_map(ixmap,iymap)=dv_map(ixmap,iymap)+dvmid*umnn
		www(ixmap,iymap)=www(ixmap,iymap)+umnn
	end do
end do
deallocate(xgrd,ygrd,dvgrd)

do iymap=1,nymap
	do ixmap=1,nxmap
		if(www(ixmap,iymap).lt.0.2) then
			dv=0
		else
			dv=dv_map(ixmap,iymap)/www(ixmap,iymap)
		end if
		dv_map(ixmap,iymap)=dv
	end do
end do


open(14,file='../../DATA/'//ar//'/'//md//'/data/dv_prev'//it//'.dat',form='binary')
write(14)xmap1,xmap2,dxmap,nxmap
write(14)ymap1,ymap2,dymap,nymap
write(14)((dv_map(ix,iy),ix=1,nxmap),iy=1,nymap)
close(14)


stop
end