subroutine read_FREE_iso_1(ar,md)
character*8 ar,md,line
character*5 fig
real xcur(1000),ycur(1000)

common/free_iso_1/nan,anom(40,400,2),val(40),nnod(40)
common/pi/pi,per
common/syn_start/ k_syn_start



iscale=0
coef_amp=1
if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/anomaly_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/anomaly_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if
do i=1,1000
	read(1,*,end=341)line	
	if(line.eq.'Scaling:')	goto 342		
end do
341 continue
!write(*,*)' cannot find SCALING'
goto 392

342	continue
read(1,*)fmap1,fmap2
read(1,*)tmap1,tmap2
read(1,*)rotate
read(1,*)coef_amp
iscale=1
sina=sin(rotate*per)
cosa=cos(rotate*per)
392 close(1)

if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/anomaly_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/anomaly_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if
do i=1,10000
	read(1,'(a8)',end=523)line
	if(line.eq.'Primary ') goto 524
end do
523 continue
write(*,*)' cannot find "Primary anomaly" !!!'
pause
524 continue
read(1,*)   
read(1,*) 
read(1,*) nform


do iform=1,nform
	read(1,*) 
	read(1,*) fig
	read(1,*) xpmin,xpmax,ypmin,ypmax
	read(1,*) value
	val(iform)=value*coef_amp

	open(2,file='../../data/'//ar//'/'//md//'/forms/'//fig//'.bln')
	read(2,*) ncurve
	xmin=10000
	xmax=-10000
	ymin=10000
	ymax=-10000
	do i=1,ncurve
		read(2,*)xcur(i),ycur(i)
		if(xcur(i).lt.xmin) xmin=xcur(i)
		if(xcur(i).gt.xmax) xmax=xcur(i)
		if(ycur(i).lt.ymin) ymin=ycur(i)
		if(ycur(i).gt.ymax) ymax=ycur(i)
	end do
	close(2)
	!write(*,*)' xmin=',xmin,' xmax=',xmax
	!write(*,*)' zmin=',zmin,' zmax=',zmax
	!pause

	dfdx=(xpmax-xpmin)/(xmax-xmin)
	dtdy=(ypmax-ypmin)/(ymax-ymin)
	if(abs(xpmin-xpmax).lt.0.000001) then
		do i=1,ncurve
			anom(iform,i,1)=xcur(i)
			anom(iform,i,2)=ycur(i)
			!write(*,*)anom(iform,i,1),anom(iform,i,2)
		end do
		nnod(iform)=ncurve+1
		anom(iform,nnod(iform),1)=xcur(1)
		anom(iform,nnod(iform),2)=ycur(1)
	else
		do i=1,ncurve
			anom(iform,i,1)=xpmin+dfdx*(xcur(i)-xmin)
			anom(iform,i,2)=ypmin+dtdy*(ycur(i)-ymin)
		end do
		nnod(iform)=ncurve+1
		anom(iform,nnod(iform),1)=xpmin+dfdx*(xcur(1)-xmin)
		anom(iform,nnod(iform),2)=ypmin+dtdy*(ycur(1)-ymin)
	end if
end do


if(iscale.eq.1) then
	write(*,*)' rotate=',rotate,' sina=',sina,' cosa=',cosa
	xmin=99999
	xmax=-99999
	ymin=99999
	ymax=-99999
	do iform=1,nform
		!write(*,*)' nnod=',nnod(iform)
		do i=1,nnod(iform)
			x1=anom(iform,i,1)
			y1=anom(iform,i,2)
			x2=x1*cosa-y1*sina
			y2=x1*sina+y1*cosa
			anom(iform,i,1)=x2
			anom(iform,i,2)=y2
			if(x2.lt.xmin) xmin=x2
			if(x2.gt.xmax) xmax=x2
			if(y2.lt.ymin) ymin=y2
			if(y2.gt.ymax) ymax=y2
		end do
	end do
	write(*,*)' xmax=',xmax,' xmin=',xmin
	write(*,*)' ymax=',ymax,' ymin=',ymin

	do iform=1,nform
		!write(*,*)' nnod=',nnod(iform)
		do i=1,nnod(iform)
			x1=anom(iform,i,1)
			y1=anom(iform,i,2)

			x2=fmap1+((fmap2-fmap1)/(xmax-xmin))*(x1-xmin)
			y2=tmap1+((tmap2-tmap1)/(ymax-ymin))*(y1-ymin)

			anom(iform,i,1)=x2
			anom(iform,i,2)=y2
		end do
	end do
end if




nan=nform
write(*,*)' FREE ISOTROPIC anomaly: nan=',nan
write(*,*)

return
end