subroutine bend_segm_refr(isrf,time)
real xs_best(100),ys_best(100),ss_best(100)
integer isrf_best(100)
real dxtmp(100)

common/lin_bend_param/segm_min_refr,bend_lin_max,bend_lin_min
common/ray_lin_srf/nseg,nod_refl,xseg(100),yseg(100),sseg(100),isrfseg(100)
common/refr_param/down
common/visual/k_prn_circle,k_prn_bend


do i=2,nseg-1
	if(isrfseg(i-1).ne.isrf.and.isrfseg(i).eq.isrf) nbnce1=i
	if(isrfseg(i+1).ne.isrf.and.isrfseg(i).eq.isrf) nbnce2=i
end do
!write(*,*)' nbnce1=',nbnce1,' nbnce2=',nbnce2


!write(*,*)' time=',time
!do i=1,nseg
	!write(*,*)i,xseg(i),yseg(i),isrfseg(i)
!end do


call renum2(isrf,nbnce1,nbnce2)


t_best=time
n_best=nseg
xs_best=xseg
ys_best=yseg
ss_best=sseg
isrf_best=isrfseg
nbbest1=nbnce1
nbbest2=nbnce2

bend_max=bend_lin_max

234 continue

i_success=0

nsegg=nseg
do nod_cur0=1,nsegg

	if(nod_cur0.eq.1) then
		nod_cur=nbnce1
	else if(nod_cur0.eq.2) then
		nod_cur=nbnce2
	else
		nod_cur=nod_cur0-1
		if(nod_cur.ge.nbnce1.and.nod_cur.le.nbnce2) cycle 
	end if

	index=1
	ifirst=1
	bend=bend_max

	221 continue

	nseg=n_best
	xseg=xs_best
	yseg=ys_best
	sseg=ss_best
	isrfseg=isrf_best
	nbnce1=nbbest1
	nbnce2=nbbest2

	!write(*,*)' start'
	do i=1,nseg
		!write(*,*)i,xseg(i),yseg(i),isrfseg(i)
		if(i.ne.nseg.and.i.ne.1.and.isrfseg(i).eq.0) pause
	end do


	val_bend = index * bend

337 continue
	smid=sseg(nod_cur)


	nn1=2
	nn2=nseg-1
	if(nod_cur.le.nbnce1) then
		nn2=nbnce1
		slim1=sseg(1)
		slim2=sseg(nbnce1)+1
	else if(nod_cur.ge.nbnce2) then
		nn1=nbnce2
		slim1=sseg(nbnce2)-1
		slim2=sseg(nseg)
	end if

	dxtmp = 0 
	do iseg=nn1,nn2
		if(iseg.gt.nbnce1.and.iseg.lt.nbnce2) cycle 
		sss=sseg(iseg)

		if((sss-slim1)*(sss-slim2).gt.0) cycle


		if((sss-slim1)*(sss-smid).le.0.) then
			unit=(sss-slim1)/(smid-slim1)
			d_value=val_bend*unit
		end if

		if((sss-slim2)*(sss-smid).le.0.) then
			unit=(sss-slim2)/(smid-slim2)
			d_value=val_bend*unit
		end if

		dxtmp(iseg)= d_value 
		!write(*,*)' sss=',sss,' dx=',dxtmp(iseg)

	end do


	do iseg=nn1,nn2
		xseg(iseg)=xseg(iseg)+dxtmp(iseg)
		if(iseg.gt.nbnce1.and.iseg.lt.nbnce2) cycle 
		inter=isrfseg(iseg)
		if(inter.eq.0) then
			write(*,*)' inter=',inter
			pause
		end if
		call yyy_interface(xseg(iseg),inter, yyy,kod)
		yseg(iseg)=yyy
		if(iseg.eq.nbnce1.or.iseg.eq.nbnce2) yseg(iseg)=yyy-down 
	end do

	ntmp=nseg

	!write(*,*)' before renumbering'
	do i=1,nseg
		!write(*,*)i,xseg(i),yseg(i),isrfseg(i)
		if(i.ne.nseg.and.i.ne.1.and.isrfseg(i).eq.0) pause
	end do

	call renum2(isrf,nbnce1,nbnce2)


	!write(*,*)' after renumbering'
	do i=1,nseg
		!write(*,*)i,xseg(i),yseg(i),isrfseg(i)
		if(i.ne.nseg.and.i.ne.1.and.isrfseg(i).eq.0) pause
	end do


	!if(nseg.ne.ntmp) then
		!write(*,*)' after renumbering: nseg=',nseg,' ntmp=',ntmp
	!end if


	sseg(1)=0
	do iseg=2,nseg
		!write(*,*)xbend(i),ybend(i)
		x1=xseg(iseg-1)
		x2=xseg(iseg)
		y1=yseg(iseg-1)
		y2=yseg(iseg)
		ds=sqrt((x2-x1)**2+(y2-y1)**2)
		sseg(iseg)=sseg(iseg-1)+ds
	end do

	iicur=iicur+1

	time = time_lin_srf()

!	write(*,*)iicur,' nod_cur=',nod_cur,' bend=',bend*index,' time=',time

!	if(iicur.ge.123.and.iicur.le.124)then
!		do i=1,nseg
!			write(*,*)i,xseg(i),yseg(i),isrfseg(i)
!		end do
!		val_bend=-1
!		if(iicur.eq.124) then
!			time = time_lin_srf_test()
!			write(*,*)' time=',time
!			stop
!		end if
!		goto 337
!	end if
		

	if(time.lt.t_best) then

		ntmp=n_best

		t_best=time
		n_best=nseg
		xs_best=xseg
		ys_best=yseg
		ss_best=sseg
		isrf_best=isrfseg
		nbbest1=nbnce1
		nbbest2=nbnce2
		ifirst=ifirst+1
		i_success=i_success+1
		!write(*,*)' success!!! t_best=',t_best,' x=',xseg(nod_cur),ntmp,n_best
		if(ntmp.ne.n_best) then
			!write(*,*)' ntmp=',ntmp,' n_best=',n_best
			!pause
			goto 234
		end if
		goto 221
	else
		if(index.eq.1.and.ifirst.eq.1) then
			index=-1
			!write(*,*)' NO success!!! index=',index
			!pause
			goto 221
		else
			index=1
			ifirst=1
			bend=bend/2.
			!write(*,*)' NO success!!! bend=',bend
			!pause
			if(bend.gt.bend_lin_min) goto 221
		end if
	end if

	!open(21,file='ray_cur.bln')
	!write(43,*)n_best
	if(k_prn_bend.ne.0) then
		do i=1,n_best
			write(43,*)xs_best(i),ys_best(i)
			!write(*,*)i,xs_best(i),ys_best(i)
		end do
	end if
	!close(21)

	!open(21,file='ray_cur.bln')
	!write(31,*)n_best
	!do i=1,n_best
		!write(31,*)xs_best(i),ys_best(i)
		!write(*,*)i,xs_best(i),ys_best(i)
	!end do
	!close(21)
	!write(*,*)' nod_cur0=',nod_cur0,' nod_cur=',nod_cur,' t_best=',t_best
	!pause


end do ! nod_cur0

!write(*,*)' i_success=',i_success

if(i_success.ne.0) then
	bend_max=bend_max/2.
	if(bend_max.gt.bend_lin_min) goto 234
end if

!open(31,file='ray_best.bln')
!write(31,*)n_best
!do i=1,n_best
!	write(31,*)xs_best(i),ys_best(i)
	!write(*,*)i,xs_best(i),ys_best(i)
!end do
!close(31)




xseg=xs_best
yseg=ys_best
sseg=ss_best
tout=t_best
isrfseg=isrf_best
nbnce1=nbbest1
nbnce2=nbbest2

!write(*,*)' after segment bending: tout=',tout


return
end