USE DFPORT

character*8 ar,md,line
allocatable plotray(:,:),sumver(:)
real xgrd(100000),ygrd(100000)
integer kotr(500000,2),kline(2,1000)
common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min
common/lay_num/lay_num
common/syn_start/ k_syn_start


k_syn_start=1

open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
read(1,*)iter
close(1)

key_preview=0
open(1,file='../../preview_key.txt')
read(1,*,end=771)key_preview
771 close(1)

if(key_preview.ne.0) then
	i=system('mkdir ..\..\PICS\'//ar//'\'//md)
	open(1,file='../../data/'//ar//'/config.txt')
	read(1,*) npix_x,npix_y
	read(1,*)tick_x,tick_y
	close(1)

	open(1,file='../../DATA/'//ar//'/set_vis.dat')
	read(1,*) xmap1,xmap2,dxmap  
	read(1,*) ymap1,ymap2,dymap  
	close(1)
	i=system('copy ..\..\COMMON\visual_exe\visual.exe layers.exe')

end if







!******************************************************************
open(1,file='../../data/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=533)line
	if(line.eq.'GRID_PAR') goto 534
end do
533 continue
write(*,*)' cannot find GRID_PARAMETERS in MAJOR_PARAM.DAT!!!'
pause
534 continue
read(1,*)
read(1,*)
read(1,*)
read(1,*)
read(1,*)distmin
read(1,*)plotmin,plotmax	! maximal ray density, relative to average
read(1,*)dystep0			! step of movement along z
read(1,*)kod_surf			! if not 0, allow sharp contrast on interfaces
close(1)
!******************************************************************

nrlf=0
sea_lev=0
v_air=0.01
v_sea=1.0
v_min=1
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue



if(kod_surf.ne.0) then
	open(1,file='../../DATA/'//ar//'/'//md//'/abs_vel_syn.dat')
	read(1,*) kod_abs
	close(1)
	
	if(kod_abs.ne.4) then
		write(*,*)' kod_abs=',kod_abs
		write(*,*)' in this case it should be equal 4'
		pause
	end if  



	call read_abs_INTERF(ar,md)
	
	!xxx=-4900
	!do isurf=1,nsurf
	!	call yyy_interface(xxx,isurf, yyy,kod)
	!	write(*,*)' isurf=',isurf,' yyy=',yyy,' kod=',kod
	!end do
	!pause

end if




open(1,file='../../DATA/'//ar//'/'//md//'/data/raydens.dat',form='binary')
read(1)xlim1,xlim2,nxpl,dxpl
read(1)ylim1,ylim2,nypl,dypl
write(*,*)' nxpl=',nxpl,' nypl=',nypl

allocate(plotray(nxpl,nypl),sumver(nxpl))

read(1)((plotray(ix,iy),ix=1,nxpl),iy=1,nypl)
close(1)

nonzer=0
sumtotal=0
do iy=1,nypl
	do ix=1,nxpl
		if(plotray(ix,iy).lt.1.)cycle
		nonzer=nonzer+1
		sumtotal=sumtotal+plotray(ix,iy)
	end do
end do
close(1)
averplot=sumtotal/nonzer
write(*,*)' averplot=',averplot,' nonzer=',nonzer
nparam=nonzer

do iy=1,nypl
	do ix=1,nxpl
		if(plotray(ix,iy).gt.averplot*plotmax)then
			plotray(ix,iy)=averplot*plotmax
		else if(plotray(ix,iy).lt.averplot*plotmin)then
			plotray(ix,iy)=0.
		end if
	end do
end do

sumtotal=0
do ix=1,nxpl
	sumver(ix)=0
	do iy=1,nypl
		sumver(ix)=sumver(ix)+plotray(ix,iy)
	end do
	sumtotal=sumtotal+sumver(ix)
end do

node=0

sign=abs(ylim2-ylim1)/(ylim2-ylim1)
dystep = dystep0*sign

do ix=1,nxpl
	xcur=xlim1+(ix-0.5)*dxpl
	ybot=relieff(xcur)
	!write(*,*)' nparam,sumver(ix),sumtotal=',nparam,sumver(ix),sumtotal

	ngrd=int_best(nparam*sumver(ix)/sumtotal)
	if(ngrd.eq.0) cycle
	!write(*,*)' ngrd=',ngrd
	porog=sumver(ix)/(ngrd*2)

	sum=0
	dist=0
	nnod2=0

	do ycur=ylim1,ylim2,dystep
		!write(*,*)' ycur=',ycur,' ylim2=',ylim2
		dist=dist+abs(dystep)
		do iy=1,nypl
			y1=ylim1+(iy-1)*dypl
			y2=y1+dypl
			if((ycur-y1)*(ycur-y2).le.0.) goto 662
		end do
		write(*,*)' cannot find for ycur=',ycur
		pause

662		continue
		if(plotray(ix,iy).lt.1) cycle
		dsum=plotray(ix,iy)*abs(dystep)/abs(dypl)
		sum=sum+dsum
		!write(*,*)' dist=',dist,' sum=',sum,' porog=',porog
		if(sum.lt.porog) cycle
		if(mod(nnod2,2).ne.0) then
			sum=0
			nnod2=nnod2+1
			!write(*,*)' nnod2=',nnod2
			cycle
		else
			if(dist.lt.distmin) cycle
			if(ycur.gt.ybot) cycle
			sum=0
			nnod2=nnod2+1
			!write(*,*)' nnod2=',nnod2,' ycur=',ycur,' dist=',dist
			dist=0
			node=node+1
			xgrd(node)=xcur
			ygrd(node)=ycur
			cycle
		end if
	end do
	!write(*,*)' ix=',ix,' node=',node


end do

write(*,*)' node=',node

open(11,file='../../data/'//ar//'/'//md//'/data/grid.dat')
open(21,file='../../FIG_files/rays/nodes.dat')
write(11,*)node
do i=1,node
	write(11,*)xgrd(i),ygrd(i)
	write(21,*)xgrd(i),ygrd(i),0.
end do
close(11)
close(21)

! Find the neighbouring nodes:

! along the vertical lines:
notr=0
do inod=1,node-1
	x1=xgrd(inod)
	x2=xgrd(inod+1)
	if(abs(x1-x2).gt.0.0001) cycle
	if(kod_surf.ne.0) then
		y1=ygrd(inod)
		y2=ygrd(inod+1)

		call abs_FREE_iso(x1,y1,vel1)
		lay1=lay_num
		call abs_FREE_iso(x2,y2,vel2)
		lay2=lay_num

		if(lay1.ne.lay2) goto 331

	end if

	notr=notr+1
	kotr(notr,1)=inod
	kotr(notr,2)=inod+1
331	continue
end do

do ix=1,nxpl
	xline1=xlim1+(ix-0.5)*dxpl
	xline2=xlim1+(ix+0.5)*dxpl
	nln1=0
	nln2=0
	do inod=1,node
		xxx=xgrd(inod)

		if(abs(xxx-xline1).lt.0.001) then
			nln1=nln1+1
			kline(1,nln1)=inod
		end if

		if(abs(xxx-xline2).lt.0.001) then
			nln2=nln2+1
			kline(2,nln2)=inod
		end if
	end do
	if (nln1.eq.0.or.nln2.eq.0) cycle

	!write(*,*)' nln1=',nln1,' nln2=',nln2

	iln1=1
	iln2=1

441	continue
	kln1=kline(1,iln1)
	kln2=kline(2,iln2)


	y1=ygrd(kln1)
	y2=ygrd(kln2)

	if(kod_surf.ne.0) then
		x1=xline1
		x2=xline2

		call abs_FREE_iso(x1,y1,vel1)
		lay1=lay_num
		call abs_FREE_iso(x2,y2,vel2)
		lay2=lay_num

		if(lay1.ne.lay2) goto 332

	end if


	notr=notr+1
	kotr(notr,1)=kln1
	kotr(notr,2)=kln2

332	continue

	dy_1_22=99999
	dy_11_2=99999
	ind=0

	if(iln1+1.le.nln1) then
		kln11=kline(1,iln1+1)
		y11=ygrd(kln11)
		dy_11_2=abs(y11-y2)
		ind=1
	end if

	if(iln2+1.le.nln2) then
		kln22=kline(2,iln2+1)
		y22=ygrd(kln22)
		dy_1_22=abs(y1-y22)
		ind=1
	end if
	if(ind.eq.0) cycle
	!write(*,*)' dy_1_22=',dy_1_22,' dy_11_2=',dy_11_2

	if(dy_1_22 .lt. dy_11_2) then
		iln2=iln2+1
	else
		iln1=iln1+1
	end if
	goto 441
end do
write(*,*)' notr=',notr

open(11,file='../../data/'//ar//'/'//md//'/data/otr.dat')
write(11,*) notr
do i=1,notr
	write(11,*)(kotr(i,i2),i2=1,2)
end do
close(11)


open(21,file='../../FIG_files/rays/otr.bln')
do i=1,notr
	x1=xgrd(kotr(i,1))
	y1=ygrd(kotr(i,1))
	x2=xgrd(kotr(i,2))
	y2=ygrd(kotr(i,2))
	write(21,*)2
	write(21,*)x1,y1
	write(21,*)x2,y2
end do
close(21)

if(key_preview.eq.0) stop

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************

open(14,file='config.txt')
write(14,*)npix_x,npix_y
write(14,*)'_______ Size of the picture in pixels (nx,ny)'
write(14,*)xmap1,xmap2
write(14,*)'_______ Physical coordinates along X (xmin,xmax)'
write(14,*)ymap1,ymap2
write(14,*)'_______ Physical coordinates along Y (ymin,ymax)'
write(14,*)tick_x,tick_y
write(14,*)'_______ Spacing of ticks on axes (dx,dy)'
write(14,151)ar,md
151 format('..\..\PICS\',a8,'\',a8,'\nodes_rays 1.png')
write(14,*)'_______ Path of the output picture'
write(14,3532)
3532 format(' Parameterization nodes and ray paths after iteration 1')
write(14,*)'_______ Title of the plot on the upper axe'
write(14,*)	1
write(14,*)'_______ Number of layers'

59 format('********************************************')

write(14,59)
write(14,*)	2
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,55)
55 format('..\..\FIG_files\rays\rays 1.bln')
write(14,*)'_______ Location of the BLN file'
write(14,*)	1
write(14,*)'_______ Thickness of line in pixels'
write(14,*)	210,210,210
write(14,*)'_______ RGB color'

write(14,59)
write(14,*)	2
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,54)ar
54 format('..\..\DATA\',a8,'\inidata\relief.bln')
write(14,*)'_______ Location of the BLN file'
write(14,*)	5
write(14,*)'_______ Thickness of line in pixels'
write(14,*)	0,0,0
write(14,*)'_______ RGB color'


write(14,59)
write(14,*)	2
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,56)
56 format('..\..\FIG_files\rays\otr.bln')
write(14,*)'_______ Location of the BLN file'
write(14,*)	1
write(14,*)'_______ Thickness of line in pixels'
write(14,*)	255,0,0
write(14,*)'_______ RGB color'


write(14,59)
write(14,*)	3
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,57)
57 format('..\..\FIG_files\rays\nodes.dat')
write(14,*)'_______ Location of the DAT file'
write(14,*)	1
write(14,*)'_______ Symbol (1: circle, 2: square)'
write(14,*)	3
write(14,*)'_______ Size of dots in pixels'
write(14,*)	0,0,0
write(14,*)'_______ RGB color'

close(14)



close(14)

i=system('layers.exe')


stop
end