USE DFPORT
character*8 md,ar,line,md_all(200),ar_all(200)
integer it_all(200)
character*40 line40(10)

nmodel=0
open(1, file='../../model_all.dat')
read(1,*)
read(1,*)
2	read(1,'(a8,1x,a8)',end=1) ar,md
	nmodel=nmodel+1
	ar_all(nmodel)=ar
	md_all(nmodel)=md
	write(*,*)nmodel,' area=',ar,' model=',md
	goto 2
1 close(1)

i=system('mkdir ..\..\tmp')
i=system('mkdir ..\..\FIG_files\rays')
i=system('mkdir ..\..\FIG_files\result')
i=system('mkdir ..\..\FIG_files\syn_mod')
i=system('mkdir ..\..\FIG_files\stat')

do imodel=1,nmodel
	ar=ar_all(imodel)
	md=md_all(imodel)


	open(1,file='../../data/'//ar//'/'//md//'/MAJOR_PARAM.DAT')
	do i=1,10000
		read(1,'(a8)',end=563)line
		if(line.eq.'GENERAL ') goto 564
	end do
	563 continue
	write(*,*)' cannot find GENERAL INFORMATION in MAJOR_PARAM.DAT!!!'
	pause
	564 continue
	read(1,*)key_1real_2syn
	read(1,*)niter
	close(1)

	if(key_1real_2syn.eq.1) write(*,*)' REAL DATA INVERSION, iterations:',niter		
	if(key_1real_2syn.eq.2) write(*,*)' SYNTHETIC MODELING, iterations:',niter	



	open(11,file='../../model.dat')
	write(11,'(a8)')ar		
	write(11,'(a8)')md		
	close(11)
	write(*,*)' model:',md
	write(*,*)' iterations:',niter
	i=system('mkdir ..\..\DATA\'//ar//'\'//md//'\DATA')

	open(1,file='../../PROG/a_define_model/SET.DAT')
	read(1,'(i1,a40)')i,line40(1)		
	read(1,'(i1,a40)')i_small,line40(2)	
	close(1)

	if(key_1real_2syn.eq.2) then		
		open(11,file='../../PROG/a_define_model/SET.DAT')
		write(11,'(i1,a40)')2,line40(1)		
		write(11,'(i1,a40)')i_small,line40(2)	
		close(11)	

		write(*,*)'	 ****************************************************'
		write(*,*)'	 Defining synthetic rays: '
		i=system('..\a_define_model\define_model.exe')

		write(*,*)'	 ****************************************************'
		write(*,*)'	 Tracing synthetic rays: '
		i=system('..\a_syn_tracing\syn_tracing.exe')
	end if
	open(11,file='../../PROG/a_define_model/SET.DAT')
	write(11,'(i1,a40)')1,line40(1)		
	write(11,'(i1,a40)')i_small,line40(2)	
	close(11)	

	write(*,*)'	 ****************************************************'
	write(*,*)'	 Defining synthetic rays: '
	i=system('..\a_define_model\define_model.exe')

	do iter=1,niter

		write(*,*)' ITERATION:',iter

		open(11,file='../../model.dat')
		write(11,'(a8)')ar		
		write(11,'(a8)')md		
		write(11,'(i2)')iter		
		close(11)


		write(*,*)'	 ****************************************************'
		write(*,*)'	 Tracing direct rays: iter=',iter
		i=system('..\1_tracing\tracing.exe')

		if(iter.eq.1) then

			write(*,*)'	 ****************************************************'
			write(*,*)'	 Compute the ray density'
			i=system('..\2_ray_density\ray_dens.exe')
			write(*,*)'	 ****************************************************'
			write(*,*)'	 Compute the parameterization grid:'
			i=system('..\3_grid\grid.exe')
		end if

		write(*,*)'	 ****************************************************'
		write(*,*)'	 Compute the matrix, iter=',iter
		i=system('..\4_matr\matr.exe')
		i=system('..\5_invers\invers.exe')

		i=system('..\6_2d_model\model_2d.exe')

		i=system('..\vis_result\vis_result.exe')
	end do
	i=system('..\var_reduct\resid_norm.exe')
end do




stop
end