subroutine read_FREE_abs(ar,md)
character*8 ar,md,line
character*5 fig
real xcur(1000),ycur(1000)

common/free_abs/vback,nan,xaa(40),yaa(40),vaa(40),xbb(40),ybb(40),vbb(40),anom(40,2000,2),nnod(40)
common/pi/pi,per
common/syn_start/ k_syn_start

iscale=0
coef_amp=1



if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if

if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if
do i=1,1000
	read(1,*,end=341)line	
	if(line.eq.'Scaling:')	goto 342		
end do
341 continue
!write(*,*)' cannot find SCALING'
goto 392

342	continue
read(1,*)fmap1,fmap2
read(1,*)tmap1,tmap2
read(1,*)rotate
read(1,*)coef_amp
iscale=1
sina=sin(rotate*per)
cosa=cos(rotate*per)
392 close(1)

if(k_syn_start.eq.1) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_start.dat')
else if(k_syn_start.eq.2) then
	open(1,file='../../DATA/'//ar//'/'//md//'/velocity_syn.dat')
else
	write(*,*)' k_syn_start is not defined:',k_syn_start
	pause
end if
read(1,*)   
read(1,*) 
read(1,*) vback
read(1,*) nform


do iform=1,nform
	read(1,*) 
	read(1,*) fig
	read(1,*) xaa(iform),yaa(iform),vaa(iform)
	read(1,*) xbb(iform),ybb(iform),vbb(iform)

	open(2,file='../../data/'//ar//'/'//md//'/forms/'//fig//'.bln')
	read(2,*) ncurve
	do i=1,ncurve
		read(2,*)xcur(i),ycur(i)
	end do
	close(2)
	!write(*,*)' xmin=',xmin,' xmax=',xmax
	!write(*,*)' zmin=',zmin,' zmax=',zmax
	!pause

	do i=1,ncurve
		anom(iform,i,1)=xcur(i)
		anom(iform,i,2)=ycur(i)
		!write(*,*)anom(iform,i,1),anom(iform,i,2)
	end do
	nnod(iform)=ncurve+1
	anom(iform,nnod(iform),1)=xcur(1)
	anom(iform,nnod(iform),2)=ycur(1)
end do


if(iscale.eq.1) then
	write(*,*)' rotate=',rotate,' sina=',sina,' cosa=',cosa
	xmin=99999
	xmax=-99999
	ymin=99999
	ymax=-99999
	do iform=1,nform
		!write(*,*)' nnod=',nnod(iform)
		do i=1,nnod(iform)
			x1=anom(iform,i,1)
			y1=anom(iform,i,2)
			x2=x1*cosa-y1*sina
			y2=x1*sina+y1*cosa
			anom(iform,i,1)=x2
			anom(iform,i,2)=y2
			if(x2.lt.xmin) xmin=x2
			if(x2.gt.xmax) xmax=x2
			if(y2.lt.ymin) ymin=y2
			if(y2.gt.ymax) ymax=y2
		end do
	end do
	!write(*,*)' xmax=',xmax,' xmin=',xmin
	!write(*,*)' ymax=',ymax,' ymin=',ymin

	do iform=1,nform
		!write(*,*)' nnod=',nnod(iform)
		do i=1,nnod(iform)
			x1=anom(iform,i,1)
			y1=anom(iform,i,2)

			x2=fmap1+((fmap2-fmap1)/(xmax-xmin))*(x1-xmin)
			y2=tmap1+((tmap2-tmap1)/(ymax-ymin))*(y1-ymin)

			anom(iform,i,1)=x2
			anom(iform,i,2)=y2
		end do
	end do
end if




nan=nform
write(*,*)' FREE ISOTROPIC ABSOLUTE model: nan=',nan
write(*,*)

return
end