subroutine SYN_VEL_2D(x,y,vel)
common/velsyn_2d/xmod1,xmod2,dxmod,nxmod,ymod1,ymod2,dymod,nymod,vel_2D(2881,2135)

vel = 0
if(nxmod.eq.0) return

xmod2=xmod1+dxmod*nxmod
ymod2=ymod1+dymod*nymod

if((x-xmod1)*(x-xmod2).gt.0.) return
if((y-ymod1)*(y-ymod2).gt.0.) return

do ix=1,nxmod-1
	x1=xmod1+(ix-1)*dxmod
	x2=xmod1+(ix)*dxmod
	if((x-x1)*(x-x2).le.0.) exit
end do

do iy=1,nymod-1
	y1=ymod1+(iy-1)*dymod
	y2=ymod1+(iy)*dymod
	if((y-y1)*(y-y2).le.0.) exit
end do

v11=vel_2D(ix,iy)
v21=vel_2D(ix+1,iy)
v12=vel_2D(ix,iy+1)
v22=vel_2D(ix+1,iy+1)

v1=v11+((v21-v11)/(x2-x1))*(x-x1)
v2=v12+((v22-v12)/(x2-x1))*(x-x1)

vel = v1+((v2-v1)/(y2-y1))*(y-y1)


return
end 