subroutine bend_regular(xxx1,yyy1,xxx2,yyy2,kod_prev, tray)

! kod_prev=0: initial shape is a streight line
! kod_prev=1: initial shape is from a common block /ray_xyv/


common/ray_xyv/nray,xray(10000),yray(10000),vray(10000),sray(10000)
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max
common/visual/k_prn_circle,k_prn_bend
common/pi/pi,per

real xprev(10000),yprev(10000),vprev(10000),sprev(10000)


real xxray(10000),yyray(10000),vvray(10000),ssray(10000)
real vtmp(10000),smega1(10000),smega2(10000),bend_mega(10000)
real dxray(10000),dyray(10000)
real dxbest(10000),dybest(10000),vbest(10000)
real dxunit(10000),dyunit(10000)
integer nmega1(100),nmega2(100)


dxunit=0
dyunit=0
if(kod_prev.eq.0) then
	call bend_initial(xxx1,yyy1,xxx2,yyy2, tray)
else if(kod_prev.eq.1) then
	ttt=0
	do inod=2,nray
		ds=sray(inod)-sray(inod-1)
		vm=(vray(inod)+vray(inod-1))/2.
		ttt=ttt+ds/vm
	end do
	tray=ttt
end if

!write(*,*)' tray=',tray




do i=2,nray
	x1=xray(i-1)
	y1=yray(i-1)
	x2=xray(i)
	y2=yray(i)
	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
	sray(i)=sray(i-1)+ds
end do
tray=0
do inod=2,nray
	s1=sray(inod-1)
	s2=sray(inod)
	v1=vray(inod-1)
	v2=vray(inod)
	ds=s2-s1
	vm=(v2+v1)/2.
	tray=tray+ds/vm
	!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
end do

nprev=nray
tprev=tray
xprev=xray
yprev=yray
vprev=vray
sprev=sray

!if(k_prn_bend.eq.1) open(31,file='../../FIG_files/rays/all_1_arriv.bln')

totdist=sray(nray)
nsegm_max = int_best(totdist / segm_min)
!write(*,*)' totdist=',totdist,' nsegm_max=',nsegm_max
if(nsegm_max.eq.0) nsegm_max=1
if(totdist.lt.segm_min) then
	x1=xxx1
	x2=xxx2
	xm=(x1+x2)/2.
	y1=yyy1
	y2=yyy2
	ym=(y1+y2)/2.
	vvv=velocity (xm,ym)
	tout=ds/vvv
	return
end if
do nsegm=1,nsegm_max
	dpart = 1./nsegm
	totdist=sprev(nprev)
	tmin=tprev

	dxbest=0
	dybest=0


	do iseg=1,nsegm
		spart1 = (iseg-1)* dpart * totdist
		spart2 = iseg * dpart * totdist
		smid=(spart1+spart2)/2.

		do inode=2,nprev
			s1=sprev(inode-1)
			s2=sprev(inode)
			if(s1.le.spart1.and.s2.gt.spart1) npart1=inode
			if(abs(s1-spart1).lt.0.0001) npart1=inode-1
			if(s1.lt.spart2.and.s2.ge.spart2) npart2=inode-1
			if(abs(s2-spart2).lt.0.0001) npart2=inode
		end do
		smega1(iseg)=spart1
		smega2(iseg)=spart2
		nmega1(iseg)=npart1
		nmega2(iseg)=npart2
	end do

	dxunit=0
	dyunit=0
	!write(*,*)' iseg=',iseg,' nsegm=',nsegm,' nsegm_max=',nsegm_max
	do inode=2,nprev-1
		sss=sprev(inode)

		do iseg=1,nsegm
			spart1=smega1(iseg)
			spart2=smega2(iseg)
			if((sss-spart1)*(sss-spart2).le.0) goto 992
		end do
		do iseg=1,nsegm
			spart1=smega1(iseg)
			spart2=smega2(iseg)
			!write(*,*)' spart1=',spart1,' spart2=',spart2
		end do
		write(*,*)' cannot find segment:',sss
		pause
992		continue
		smid=(spart1+spart2)/2.
		npart1=nmega1(iseg)
		npart2=nmega2(iseg)
		if(npart1.eq.npart2) cycle

		x1=xprev(npart1)
		y1=yprev(npart1)
		x2=xprev(npart2)
		y2=yprev(npart2)
		ssegm=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
		dxds=(x2-x1)/ssegm
		dyds=(y2-y1)/ssegm
		sign=abs(x2-x1)/(x2-x1)
		!write(*,*)' spart1=',spart1,' spart2=',spart2



		d_value=0.5*(cos( (2*pi / (spart2-spart1)) * (sss-smid) ) + 1.)

		!if(sss.lt.smid) then
		!	d_value = ((spart1-sss)/(spart1-smid))
		!else
		!	d_value = ((spart2-sss)/(spart2-smid))
		!end if
		!write(*,*)' sss=',sss,' d_value=',d_value
		dxunit(inode)= - d_value * dyds * sign
		dyunit(inode)=   d_value * dxds * sign

	end do

	!do i=1,nprev
	!	write(*,*)i,dxunit(i),dyunit(i)
	!end do

	vbest=vprev
	bend_mega=0


	do iseg=1,nsegm
		spart1=smega1(iseg)
		spart2=smega2(iseg)
		npart1=nmega1(iseg)
		npart2=nmega2(iseg)


		d_plus_max = bendreg_max/nsegm
		if(d_plus_max.lt.bendreg_min) goto 449 ! to exit of the subr
		d_plus = d_plus_max
		bend_prev=0
		isign=1
		ifirst=1
		ind=0
		!d_plus=0

332		continue
		d_bend = -isign * d_plus
		bend_cur = bend_prev + d_bend 

		nray=nprev

		dxray=dxbest
		dyray=dybest

		do inod=npart1,npart2
			dxray(inod) = dxbest(inod) + dxunit(inod)*bend_cur
			dyray(inod) = dybest(inod) + dyunit(inod)*bend_cur
		end do


		xray = xprev + dxray
		yray = yprev + dyray

		sray(1)=0
		do i=2,nray
			x1=xray(i-1)
			y1=yray(i-1)
			x2=xray(i)
			y2=yray(i)
			ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
			sray(i)=sray(i-1)+ds
			!write(*,*)sray(i),sprev(i)

		end do

		vray=vbest
		do i=npart1,npart2
			x=xray(i)
			y=yray(i)
			vray(i)=velocity(x,y)
		end do

		tray=0
		do inod=2,nray
			s1=sray(inod-1)
			s2=sray(inod)
			v1=vray(inod-1)
			v2=vray(inod)
			ds=s2-s1
			vm=(v2+v1)/2.
			tray=tray+ds/vm
			!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
		end do
		
!		write(*,*)' bend_cur=',bend_cur,' tray=',tray,' tmin=',tmin

!		write(*,*)' ifirst=',ifirst,' isign=',isign
!		write(*,*)' d_plus=',d_plus,' ind=',ind

		if(tray.lt.tmin) then
			!write(*,*)nsegm,iseg,' success: bend=',bend_cur,' tray=',tray
			bend_prev = bend_cur
			bend_mega(iseg) = bend_cur

			vbest=vray
			dxbest=dxray
			dybest=dyray
			tmin=tray

			ind=1

			if(ifirst.ne.1) then
				isign = 1
				d_plus = d_plus / 2.
				if(abs(d_plus).lt.bendreg_min) goto 334
			end if

		else
			if(ifirst.eq.1) then
				if(isign.eq.1) then
					if(ind.eq.0) then
						isign=-1
					else
						isign=1
						ifirst=0
						d_plus = d_plus / 2.
					end if
				else
					isign=1
					ifirst=0
					d_plus = d_plus / 2.
				end if
			else
				if(isign.eq.1) then
					isign=-1
				else
					isign=1
					d_plus = d_plus / 2.
				end if
			end if

			if(abs(d_plus).lt.bendreg_min) goto 334

		end if
!		write(*,*)' ifirst=',ifirst,' isign=',isign
!		write(*,*)' d_plus=',d_plus,' ind=',ind
!		pause
		goto 332


334		continue

	end do   

	xray=xprev+dxbest
	yray=yprev+dybest
	sray(1)=0
	do i=2,nray
		x1=xray(i-1)
		y1=yray(i-1)
		x2=xray(i)
		y2=yray(i)
		ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
		sray(i)=sray(i-1)+ds
		!write(*,*)sray(i),sprev(i)
	end do

!do i=1,nray
!	write(*,*)i,dxbest(i),dybest(i)
!end do


!	write(*,*)' before remeshing: nray=',nray,' s=',sray(nray)
!	call remeshing(1,nray,step)

!	write(*,*)' after remeshing: nray=',nray,' s=',sray(nray)

	do i=1,nray
		x=xray(i)
		y=yray(i)
		vray(i)=velocity(x,y)
	end do

	tray=0
	do inod=2,nray
		s1=sray(inod-1)
		s2=sray(inod)
		v1=vray(inod-1)
		v2=vray(inod)
		ds=s2-s1
		vm=(v2+v1)/2.
		tray=tray+ds/vm
		!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
	end do


	nprev=nray
	xprev=xray
	yprev=yray
	sprev=sray
	vprev=vray
	tprev=tray




!	open(32,file='cur_ray_path.bln')
!	write(32,*)nprev
!	do i=1,nprev
!		write(32,*)xprev(i),yprev(i)
!	end do
!	close(32)

!	write(*,*)' nsegm=',nsegm,' tray=',tray
!	pause


	if(k_prn_bend.eq.1) then	
		write(43,*)nprev
		do i=1,nprev
			write(43,*)xprev(i),yprev(i)
		end do
	end if

end do

449 continue
nray=nprev
tray=tprev
xray=xprev
yray=yprev
vray=vprev
sray=sprev

!if(k_prn_bend.eq.1) then	
!	open(42,file='../../FIG_files/rays/1_arriv.bln')
!	write(42,*)nray
!	do i=1,nray
!		write(42,*)xray(i),yray(i)
!	end do
!	close(42)
!	close(31)
!end if

!write(*,*)' END: tray=',tray


return
end