subroutine trace_1_arrival_sea(xzt,yzt,xst,yst,	xzt_bot,yzt_bot,time)
real xray2(10000),yray2(10000),vray2(10000),sray2(10000)
common/ray_xyv/nodes,xray(10000),yray(10000),vray(10000),sray(10000)
common/visual/k_prn_circle,k_prn_bend
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max
common/param_sea_bend/bendsurf_max,bendsurf_min,dy_deeper

common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min

k12_line_cos=2



k_sea_ray=0
rlf_zt=relieff(xzt)
rlf_st=relieff(xst)
if(rlf_zt.le.sea_lev.or.rlf_zt.le.sea_lev) k_sea_ray=1

if(k_sea_ray.eq.0) then
	if(k12_line_cos.eq.1) then
		!call trace_bend_2d(xzt,yzt,xst,yst, time)

	else if(k12_line_cos.eq.2) then
		call bend_initial(xzt,yzt,xst,yst, time)

	!open(31,file='cur_ray_path.bln')
	!write(31,*)nodes
	!do i=1,nodes
	!	write(31,*)xray(i),yray(i)
	!end do
	!close(31)
	!write(*,*)' prelim ray, time=',time
	!pause

		kod_prev=1
		call bend_regular(xzt,yzt,xst,yst,kod_prev, time)
	end if

	return
end if


bend_cur=bendsurf_max
xzt_bot=xzt
xbest=xzt
isign=abs(xst-xzt)/(xst-xzt)
isign0=isign
kdiv=0
tmin=9999



yzt_bot=relieff(xzt_bot)
tsea=sqrt((xzt-xzt_bot)**2+(yzt-yzt_bot)**2)/v_sea
!write(*,*)' xzt_bot=',xzt_bot,' yzt_bot=',yzt_bot,' tsea=',tsea



call bend_initial(xzt_bot,yzt_bot,xst,yst, tray)

!open(46,file='../../FIG_files/rays/ray_cur0.bln')
!write(46,*)nodes+1
!write(*,*)xzt,yzt
!do i=1,nodes
!	v=velocity(xray(i),yray(i))
!	write(*,*)xray(i),yray(i),v
!end do
!v=velocity(xst,yst)
!write(*,*)xst,yst,v

tcur=tray+tsea
tmin=tcur
xzt0 = xzt_bot
yzt0 = yzt_bot

!write(*,*)' xzt_bot=',xzt_bot,' tcur=',tcur
!pause

31 continue
		
bend = bend_cur * isign
xzt_bot = xbest + bend
yzt_bot = relieff(xzt_bot)
tsea=sqrt((xzt-xzt_bot)**2+(yzt-yzt_bot)**2)/v_sea

dxzt = xzt_bot - xzt0
dyzt = yzt_bot - yzt0
stot=sray(nodes)
do i=1,nodes
	dx=dxzt*((stot-sray(i))/stot)
	dy=dyzt*((stot-sray(i))/stot)
	xray2(i)=xray(i)+dx
	yray2(i)=yray(i)+dy
	vray2(i)=velocity(xray2(i),yray2(i))
	!write(*,*)xray(i),dx
end do

sray2(1)=0
do i=2,nodes
	x1=xray2(i-1)
	y1=yray2(i-1)
	x2=xray2(i)
	y2=yray2(i)
	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
	sray2(i)=sray2(i-1)+ds
end do
tray=0
do inod=2,nodes
	s1=sray2(inod-1)
	s2=sray2(inod)
	v1=vray2(inod-1)
	v2=vray2(inod)
	ds=s2-s1
	vm=(v2+v1)/2.
	tray=tray+ds/vm
	!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
end do

tcur=tray+tsea


!write(*,*)' xzt_bot=',xzt_bot,' tcur=',tcur


if(tcur.lt.tmin) then
	tmin=tcur
	tsea_best=tsea
	xbest=xzt_bot
	!write(*,*)' success: xbest=',xbest,' tmin=',tmin,' tray=',tray
	if(kdiv.eq.0) then
		goto 31
	else
		bend_cur=bend_cur/2.
		if(bend_cur.lt.bendsurf_min) goto 32
		isign=isign0
		goto 31
	end if
else
	if(isign.eq.isign0.and.kdiv.ne.0) then
		isign=-isign0
	else
		kdiv=1
		bend_cur=bend_cur/2.
		if(bend_cur.lt.bendsurf_min) goto 32
		isign=isign0
	end if
	goto 31
end if


32 continue
close(46)


xzt_bot = xbest
yzt_bot = relieff(xzt_bot)


dxzt = xzt_bot - xzt0
dyzt = yzt_bot - yzt0
stot=sray(nodes)
do i=1,nodes
	dx=dxzt*((stot-sray(i))/stot)
	dy=dyzt*((stot-sray(i))/stot)
	xray2(i)=xray(i)+dx
	yray2(i)=yray(i)+dy
	vray2(i)=velocity(xray2(i),yray2(i))
end do
sray2(1)=0
do i=2,nodes
	x1=xray2(i-1)
	y1=yray2(i-1)
	x2=xray2(i)
	y2=yray2(i)
	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
	sray2(i)=sray2(i-1)+ds
end do
xray=xray2
yray=yray2
sray=sray2
vray=vray2

tray=0
do inod=2,nodes
	s1=sray(inod-1)
	s2=sray(inod)
	v1=vray(inod-1)
	v2=vray(inod)
	ds=s2-s1
	vm=(v2+v1)/2.
	tray=tray+ds/vm
	!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
end do
!write(*,*)' tray=',tray


!open(51,file='../../FIG_files/rays/ray_cur1.bln')
!write(51,*)nodes+1
!write(51,*)xzt,yzt
!do i=1,nodes
!	write(51,*)xray(i),yray(i)
!end do
!close(51)
!pause




tsea=tsea_best

kod_prev=1
call bend_regular(xzt_bot,yzt_bot,xst,yst,kod_prev, tray)

time=tray+tsea

!write(*,*)' time=',time


!open(51,file='../../FIG_files/rays/ray_cur.bln')
!write(51,*)nodes
!do i=1,nodes
!	write(51,*)xray(i),yray(i)
!end do
!close(51)


return
end