subroutine trace_refracted(xzt,yzt,xst,yst,isrf,	tout)

real dxtmp(100)

real xbetw(100),ybetw(100)
real xs_best(100),ys_best(100),ss_best(100)
real xs_tmp(100),ys_tmp(100),ss_tmp(100)
real xtmp(1000),ytmp(1000),stmp(1000),vtmp(1000)
integer isrf_best(100),isrf_tmp(100)

common/ray/ nodes2,xray2(1000),yray2(1000)
common/ray_lin_srf/nseg,nod_refl,xseg(100),yseg(100),sseg(100),isrfseg(100)
common/ray_xyv/nodes,xray(1000),yray(1000),vray(1000),sray(1000)
common/ray_param/ds_ini,ds_segm_min,bend_min0,bend_max0
common/interf/nsurf,nodsrf(10),xsurf(100,10),ysurf(100,10),ksurf(100,10)
common/refr_param/down
common/lin_bend_param/segm_min_refr,bend_lin_max,bend_lin_min
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max


tout=-999

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Rough determination of bounce points on the surface
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
call refr_ray_rough(xzt,yzt,xst,yst,isrf,	time)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! accurate bending in segments

!do i=1,nseg
!	write(*,*)xseg(i),yseg(i),isrfseg(i)
!end do


do i=2,nseg
	if(isrfseg(i).lt.-900) cycle
	i1=isrfseg(i-1)
	i2=isrfseg(i)
	y1=yseg(i-1)
	y2=yseg(i)
	if(i2.lt.i1.and.y2.lt.y1) isrfseg(i)=-999
	if(i1.lt.i2.and.y1.lt.y2) isrfseg(i-1)=-999
end do

ntmp=0

do i=1,nseg
	if(isrfseg(i).lt.-900) cycle
	ntmp=ntmp+1
	xs_tmp(ntmp)=xseg(i)
	ys_tmp(ntmp)=yseg(i)
	isrf_tmp(ntmp)=isrfseg(i)
end do
nseg=ntmp
xseg=xs_tmp
yseg=ys_tmp
isrfseg=isrf_tmp

sseg(1)=0
do i=2,nseg
	x1=xseg(i-1)
	x2=xseg(i)
	y1=yseg(i-1)
	y2=yseg(i)
	ds=sqrt((x2-x1)**2+(y2-y1)**2)
	sseg(i)=sseg(i-1)+ds
end do



!do i=1,nseg
!	write(*,*)xseg(i),yseg(i),isrfseg(i)
!end do


do i=2,nseg-1
	if(isrfseg(i-1).ne.isrf.and.isrfseg(i).eq.isrf) nbnce1=i
	if(isrfseg(i+1).ne.isrf.and.isrfseg(i).eq.isrf) nbnce2=i
end do

!write(*,*)' time=',time,' nbnce1=',nbnce1,' nbnce2=',nbnce2

call renum2(isrf,nbnce1,nbnce2)


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Bending in segments along the interfaces
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
told=time
do istep=1,1
	call bend_segm_refr(isrf,time)
!	write(*,*)' istep=',istep,' time=',time
	if(abs(time-told).lt.0.00001) exit
	close(21)
	told=time
end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! segments to rays:
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do i=2,nseg-1
	if(isrfseg(i-1).ne.isrf.and.isrfseg(i).eq.isrf) nbnce1=i
	if(isrfseg(i+1).ne.isrf.and.isrfseg(i).eq.isrf) nbnce2=i
end do

call yyy_interface(xseg(nbnce1),isrf, yyy1,kod1)
call yyy_interface(xseg(nbnce2),isrf, yyy2,kod2)

xb1=xseg(nbnce1)
yb1=yseg(nbnce1)
xb2=xseg(nbnce2)
yb2=yseg(nbnce2)

ds=sqrt((xb2-xb1)**2+(yb2-yb1)**2)

if(ds.lt.bend_lin_max) then
	tout=-999
	return
end if

!write(*,*)' xseg1=',xseg(nbnce1),' yseg=',yseg(nbnce1),yyy1,' kod1=',kod1
!write(*,*)' xseg2=',xseg(nbnce2),' yseg=',yseg(nbnce2),yyy2,' kod2=',kod2

if(kod1.eq.0.or.kod2.eq.0) then
	tout=-999
	return
end if


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! segment 1 (source ->> bounce1)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

call segm2ray(1,nbnce1,time1)

!write(*,*)' time1=',time1,' nodes=',nodes

slin1=sray(nodes)
slin11=sseg(nbnce1)

!write(*,*)' slin=',slin1,' slin11=',slin11

ntmp=nodes
xtmp=xray
ytmp=yray
vtmp=vray
stmp=sray

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! segment 2 (bounce1 ->> bounce2)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

xxx1=xseg(nbnce1)
yyy1=yseg(nbnce1)
xxx2=xseg(nbnce2)
yyy2=yseg(nbnce2)

!write(*,*)' xxx1=',xxx1,' yyy1=',yyy1
!write(*,*)' xxx2=',xxx2,' yyy2=',yyy2

call segm2ray(nbnce1,nbnce2,time22)

slin2=sray(nodes)
slin22=sseg(nbnce2)-sseg(nbnce1)

!write(*,*)' time22=',time22
!write(*,*)' slin2=',slin2,' slin22=',slin22

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! BENDING OF THE LOWERMOST SEGMENT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!do istep=1,5
!	kod_prev=1
!	call bend_regular(xxx1,yyy1,xxx2,yyy2,kod_prev, time2)
!	write(*,*)' istep=',istep,' time2=',time2
!end do

!do i=1,nodes
	!write(*,*)xray(i),yray(i),vray(i),sray(i)
!end do
!write(*,*)' nodes=',nodes,' time2=',time2

do i=1,nodes
	ntmp=ntmp+1
	xtmp(ntmp)=xray(i)
	ytmp(ntmp)=yray(i)
	vtmp(ntmp)=vray(i)
	stmp(ntmp)=sray(i)+slin1
end do

slin2=stmp(ntmp)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! segment 2 (bounce2 ->> receiver)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

call segm2ray(nbnce2,nseg,time3)

!do i=1,nodes
!	write(*,*)xray(i),yray(i),vray(i),sray(i)
!end do
!write(*,*)' nodes=',nodes,' time3=',time3

do i=1,nodes
	ntmp=ntmp+1
	xtmp(ntmp)=xray(i)
	ytmp(ntmp)=yray(i)
	vtmp(ntmp)=vray(i)
	stmp(ntmp)=sray(i)+slin2
end do

nodes=ntmp
xray=xtmp
yray=ytmp
vray=vtmp
sray=stmp

time=0
do i=2,nodes
	s1=sray(i-1)
	s2=sray(i)
	v1=vray(i-1)
	v2=vray(i)
	vm=(v1+v2)/2.
	ds=s2-s1
	time=time+ds/vm
end do
!write(*,*)' ntmp=',ntmp,' time=',time
!write(*,*)' time123=',time1+time2+time3


tout=time


open(51,file='ray_final.bln')
write(51,*)nodes
do i=1,nodes
	write(51,*)xray(i),yray(i)
end do
close(51)
!tout=ttot



return
end



