function vrefmod(y)
real yref(600)
common/refmod/nref,href(600),vref(600)

yref=-href
if(nref.eq.0) then
	write(*,*)' the reference model is not defined!'
	pause
end if

!write(*,*)' z=',z,hmod(1),hmod(nref)
if(y.ge.yref(1))then
	vrefmod=vref(1)
else if(y.le.yref(nref)) then
	y1=yref(nref-1)
	y2=yref(nref)
	v1=vref(nref-1)
	v2=vref(nref)
	vrefmod=v1+((v2-v1)/(y2-y1))*(y-y1)
else
	do i=1,nref-1
		y1=yref(i)
		y2=yref(i+1)
		v1=vref(i)
		v2=vref(i+1)
		if((y1-y)*(y2-y).gt.0.) cycle
		vrefmod=v1+((v2-v1)/(y2-y1))*(y-y1)
		exit
	end do
end if

return
end 